function table() {
  return {
    tableData: [],
    highestjumps: [],
    combinedData: [], // New property to store the joined data
    groupedData: {},
    toprider: {},
    highestFirstRider: {},
    heatname: "",
    heattime: "",
    show_startcounter: false,
    show_endcounter: false,
    start_counter: "",
    end_counter: "",

    init: function () {
      this.getTableData();
      this.startintervalfunc();
    },

    getTableData: function () {
      fetch('/bigairdata')
        .then(response => response.json())
        .then(data => {
          if (data.alljumps !== null && data.alljumps !== undefined) {
            this.tableData = data.alljumps;
          }
          if (data.highestjumps !== null && data.highestjumps !== undefined) {
            this.highestjumps = data.highestjumps;
          }
          this.joinTableDataWithHighestJumps(); // Join data after fetching
          this.groupCombinedDataByTeam(); // Group the combined data
          this.sortGroupedDataByTotal();
          if (data.toprider !== null && data.toprider !== undefined) {
            this.toprider = data.toprider ? data.toprider[0] : {};
          }
          if (data.heat !== null && data.heat !== undefined) {
            this.heatname = data.heat.heatname ? data.heat.heatname : "";
            this.heattime = "Heat ends in 0:00 min";
          }

          if ((data.start_counter !== null && data.start_counter !== undefined && this.show_endcounter !== true) && (data.start_counter.hourleft > 0 || data.start_counter.minleft > 0 || data.start_counter.minsecond > 0)) {
            this.show_startcounter = true;
            this.start_counter = String.prototype.concat("Heat starts in ", data.start_counter.minleft, " : ", data.start_counter.minsecond.toString().padStart(2, '0'), " min");
          }

          if ((data.end_counter !== null && data.end_counter !== undefined && this.show_startcounter !== true) && (data.end_counter.hourleft > 0 || data.end_counter.minleft > 0 || data.end_counter.minsecond > 0)) {
            this.show_endcounter = true;
            this.end_counter = String.prototype.concat("Heat end in ", data.end_counter.hourleft, " : ", data.end_counter.minleft, " : ", data.end_counter.minsecond.toString().padStart(2, '0'), " min");
          }
        });
    },

    // Method to join tableData with highestjumps based on a common property
    joinTableDataWithHighestJumps: function () {
      this.combinedData = this.tableData.map(jump => {
        const highestJump = this.highestjumps.find(hj => hj.team === jump.team); // Assuming riderId is the common property
        return {
          ...jump, ...highestJump
        }
      });
    },
    calculateTotal: function (items) {
      return items.reduce((total, item) => {
        return total + (parseFloat(item.highest) || 0);
      }, 0).toFixed(1);
    },
    getIntPart: function (total) {
      return total.split('.')[0];
    },

    getDecimalPart: function (total) {
      return total.split('.')[1] ? `.${total.split('.')[1]}` : '';
    },
    // Method to group the combined data by team property
    groupCombinedDataByTeam: function () {
      this.groupedData = this.combinedData.reduce((groups, item) => {
        const team = item.team || 'Unknown';
        if (!groups[team]) {
          groups[team] = [];
        }
        groups[team].push(item);
        return groups;
      }, {});
    },
    sortGroupedDataByTotal: function () {
      const sortedEntries = Object.entries(this.groupedData).sort(([, itemsA], [, itemsB]) => {
        const totalA = parseFloat(this.calculateTotal(itemsA));
        const totalB = parseFloat(this.calculateTotal(itemsB));
        return totalB - totalA;  // Sort descending by total score
      });

      this.groupedData = Object.fromEntries(sortedEntries);
    },
    startintervalfunc: function () {
      setInterval(() => {
        this.getTableData();
      }, 1000);
    }
  }
}




var elkeSwiper = new Swiper(".elke-swiper", {
  direction: "horizontal",
  slidesPerView: 1,
  spaceBetween: 0,
  navigation: {
    prevEl: ".swiper-custom-prev",
    nextEl: ".swiper-custom-next",
  },
  breakpoints: {
    1024: {
      slidesPerView: 3,
    },
  },
  mousewheel: {
    releaseOnEdges: true,
  },
  keyboard: true,
});

var cardsSwiper = new Swiper(".cards-swiper", {
  direction: "horizontal",
  slidesPerView: 1,
  spaceBetween: 20,
  breakpoints: {
    640: {
      slidesPerView: 2,
    },
    1024: {
      slidesPerView: 3,
    },
  },
  mousewheel: {
    releaseOnEdges: true,
  },
  keyboard: true,
});

var cardsSwiper = new Swiper(".products-swiper", {
  direction: "horizontal",
  slidesPerView: 1,
  spaceBetween: 40,
  breakpoints: {
    640: {
      slidesPerView: 2,
    },
    1024: {
      slidesPerView: 3,
    },
  },
  mousewheel: {
    releaseOnEdges: true,
  },
  keyboard: true,
});
