const defaultTheme = require("tailwindcss/defaultTheme");

module.exports = {
  content: ["./src/**/*.{html,js}"],
  theme: {
    extend: {
      screens: {
        xs: "401px",
        "xs-down": { max: "400px" },
        sm: "641px",
        "sm-down": { max: "640px" },
        md: "769px",
        "md-down": { max: "768px" },
        lg: "1025px",
        "lg-down": { max: "1024px" },
        xl: "1171px",
        "xl-down": { max: "1170px" },
        "2xl": "1281px",
        "2xl-down": { max: "1280px" },
        "3xl": "1441px",
        "3xl-down": { max: "1440px" },
        "4xl": "1921px",
        "4xl-down": { max: "1920px" },
      },
      container: {
        center: true,
        padding: "1rem",
      },
      colors: {
        body: {
          DEFAULT: "#001003",
        },
        accent: "#f3c545",
        success: "#2aaf4f",
        player: "#091b2c",
        border: {
          DEFAULT: "rgba(0,0,0,0.2)",
        },
      },
      fontSize:{
        "2.5xl": "1.625rem"
      },
      fontFamily: {
        ttlakes: ["TT Lakes", ...defaultTheme.fontFamily.sans],
      },
    },
  },
  variants: {
    extend: {
      letterSpacing: ["hover", "focus"],
    },
  },
  plugins: [require("@tailwindcss/line-clamp")],
};
